stages:
  - test
  - deploy

variables:
  APP_CONTAINER_DIR: "${CI_PROJECT_DIR}"

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE == "push"


include:
  - project: 'renovate-bot/renovate-runner'
    file: '/templates/renovate.gitlab-ci.yml'

renovate:
  variables:
    RENOVATE_EXTRA_FLAGS: $CI_PROJECT_PATH

static-analysis:
  stage: test
  image: rust:1.71.1
  script:
    - rustup component add clippy
    - cargo clippy
    - cargo install cargo-machete
    - cargo machete

unit-test:
  stage: test
  image: rust:1.71.1
  script:
    - cargo test --all

build-and-deploy-app:
  # Only builds of main are picked up by flux to be deployed.
  stage: deploy
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - echo "CI_PIPELINE_SOURCE is $CI_PIPELINE_SOURCE"
    - /kaniko/executor
      --context="${APP_CONTAINER_DIR}"
      --dockerfile="${APP_CONTAINER_DIR}/tools/app_container/Dockerfile"
      --destination="${CONTAINER_REGISTRY_HOST}/${CI_PROJECT_PATH}:${CI_COMMIT_SHORT_SHA}-${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_IID}"
      --destination="${CONTAINER_REGISTRY_HOST}/${CI_PROJECT_PATH}:${CI_COMMIT_REF_SLUG}"
      --cache="true"
      --cache-ttl="168h"
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE == "push"
      when: on_success
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: on_success
